#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"

#define SCREEN_WIDTH    600
#define SCREEN_HEIGHT   600

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Sandpiles 4", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0, SDL_ALPHA_OPAQUE));

    static int table[2][SCREEN_WIDTH + 2][SCREEN_HEIGHT + 2];
    int currentTable = 0;

    // initialise the table
    for (int y = 1; y <= SCREEN_HEIGHT; ++y)
        for (int x = 1; x <= SCREEN_WIDTH; ++x)
            table[currentTable][x][y] = 0;

    table[currentTable][SCREEN_WIDTH / 2][SCREEN_HEIGHT / 2] = 400000;

    // init palette
    Color palette[5];
    palette[0] = Color(0, 0, 255);
    palette[1] = Color(0, 255, 255);
    palette[2] = Color(255, 255, 0);
    palette[3] = Color(255, 0, 0);
    palette[4] = Color(255, 255, 255);

    int counter = 0;

    while (sys.isQuitRequested() == false)
    {
        // draw the current table
        for (int y = 0; y < SCREEN_HEIGHT; ++y)
            for (int x = 0; x < SCREEN_WIDTH; ++x)
            {
                int color = table[currentTable][x + 1][y + 1];

                if (color > 4)
                    color = 4;
                gfx.setPixel(x, y, palette[color]);
            }

        counter++;
        if ((counter % 16) == 0)
            gfx.render();

        sys.processEvents();

        // update the table
        int screenSize = (SCREEN_WIDTH + 2) * (SCREEN_HEIGHT + 2);
        memcpy(table[1 - currentTable], table[currentTable], screenSize * sizeof(int));

        for (int y = 1; y <= SCREEN_HEIGHT; ++y)
            for (int x = 1; x <= SCREEN_WIDTH; ++x)
            {
                while (table[currentTable][x][y] >= 4)
                {
                    table[1 - currentTable][x][y] -= 4;
                    table[1 - currentTable][x - 1][y] += 1;
                    table[1 - currentTable][x + 1][y] += 1;
                    table[1 - currentTable][x][y - 1] += 1;
                    table[1 - currentTable][x][y + 1] += 1;
                    table[currentTable][x][y] -= 4;
                }
            }

        currentTable = 1 - currentTable;
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
